## frama-c 20191204+calcium

=== doc/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2019                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file just download the manuals in the released version

all:download


FRAMAC_SRC=..
MAKECONFIG_DIR=$(FRAMAC_SRC)/share

include $(FRAMAC_SRC)/share/Makefile.common

DOCDIR ?= "$(DESTDIR)${prefix}/share/doc"
FRAMAC_DOCDIR ?= $(DOCDIR)/frama-c

###################
# Frama-C Version #
###################

VERSION=$(shell $(SED) -e 's/\\(.*\\)/\\1/' $(FRAMAC_SRC)/VERSION)

ifeq ($(findstring +dev,$(VERSION)),+dev)
DEVELOPMENT=yes
else
DEVELOPMENT=no
endif

###

.PHONY: force


MANUALS=acsl

#MANUALS that depend on the frama-c version
VERSIONED_MANUALS=acsl-implementation aorai-manual rte-manual	\
		  wp-manual metrics-manual user-manual		\
		  plugin-development-guide eva-manual

FILES= $(addprefix manuals/, \
	 $(addsuffix -$(VERSION).pdf, $(VERSIONED_MANUALS)) \
         $(addsuffix .pdf, $(MANUALS)) \
	)


ifeq ($(DEVELOPMENT),yes)

download: force
	@echo "You can't download the manuals in this way for the development version"

else

download: force
	$(MKDIR) manuals
	wget -nv -N -P manuals \
	  $(addprefix http://frama-c.com/download/,$(addsuffix -$(VERSION).pdf, $(VERSIONED_MANUALS))) \
	  $(addprefix http://frama-c.com/download/,$(addsuffix .pdf, $(MANUALS)))

endif

install:
	$(MKDIR) $(FRAMAC_DOCDIR)
	$(CP) $(FILES) $(FRAMAC_DOCDIR)

=== src/plugins/qed/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of WP plug-in of Frama-C.                           #
#                                                                        #
#  Copyright (C) 2007-2019                                               #
#    CEA (Commissariat a l'energie atomique et aux energies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# --------------------------------------------------------------------------
# ---  Frama-C Config
# --------------------------------------------------------------------------

ifndef FRAMAC_SHARE
FRAMAC_SHARE  :=$(shell frama-c -journal-disable -print-path)
endif
ifndef FRAMAC_LIBDIR
FRAMAC_LIBDIR :=$(shell frama-c -journal-disable -print-libpath)
endif
PLUGIN_DIR ?=.

ifneq ("$(FRAMAC_INTERNAL)","yes")
include $(FRAMAC_SHARE)/Makefile.config
endif

# --------------------------------------------------------------------------
# ---  Plugin Config
# --------------------------------------------------------------------------

PLUGIN_ENABLE:=yes
PLUGIN_DYNAMIC:=yes
PLUGIN_NAME:=Qed
PLUGIN_CMO:= \
	hcons \
	listmap listset \
	intmap intset \
	idxmap idxset \
	mergemap mergeset collection \
	partition cache \
	bvars logic \
	pool kind term \
	plib pretty engine export \
	export_whycore \
	export_altergo \
	export_why3 \
	export_coq \

PLUGIN_GUI_CMO:= QedGui

PLUGIN_DEPENDENCIES:=
PLUGIN_TESTS_DIRS:=
PLUGIN_BFLAGS:=
PLUGIN_OFLAGS:=
PLUGIN_GENERATED:= $(PLUGIN_DIR)/Qed.mli

PLUGIN_DISTRIBUTED:=$(PLUGIN_ENABLED)
PLUGIN_DISTRIB_EXTERNAL:= Makefile 

include $(FRAMAC_SHARE)/Makefile.dynamic

# --------------------------------------------------------------------------
# ---  Plugin API
# --------------------------------------------------------------------------

QED_API= \
	hcons.mli \
	listset.mli listmap.mli \
	intset.mli intmap.mli \
	idxset.mli idxmap.mli \
	mergemap.mli mergeset.mli collection.mli \
	partition.mli cache.mli \
	bvars.mli \
	logic.ml \
	pool.mli kind.mli term.mli \
	plib.mli pretty.mli engine.ml export.mli \
	export_whycore.mli \
	export_altergo.mli \
	export_why3.mli \
	export_coq.mli \

QED_MLI=$(addprefix $(Qed_DIR)/, $(QED_API))

define QED_capitalize
$(shell printf "%s%s" \
	$$($(ECHO) $(1) | cut -c 1 | tr '[:lower:]' '[:upper:]')
	$$($(ECHO) $(1) | cut -c 2-))
endef

define QED_export
$(ECHO) "module $(call QED_capitalize, $(basename $(notdir $(1)))) : sig" >> $(2);
$(CAT) $(1) >> $(2);
$(ECHO) "end" >> $(2);
endef

$(Qed_DIR)/Qed.mli: $(QED_MLI)
	$(PRINT_MAKING) $@
	$(RM) $@ $@.tmp
	$(ECHO) "(* This file is generated. Do not edit. *)" > $@.tmp
	$(ECHO) "(** {b Qed Public API} *)" > $@.tmp
	$(foreach file,$(QED_MLI),$(call QED_export,$(file),$@.tmp))
	$(CHMOD_RO) $@.tmp
	$(MV) $@.tmp $@

clean::
	$(RM) $(Qed_DIR)/Qed.mli

# --------------------------------------------------------------------------

=== debian/changelog ===
frama-c (20191204+calcium-0.1) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * New upstream release (Closes: #944365)
  * Add dependencies on libyojson-ocaml-dev and libwhy3-ocaml-dev
  * Refresh patches
  * Drop patches now upstream:
    - 0006-Fix-installation-on-bytecode-architectures.patch
    - 0007-Fix-FTBFS-with-OCaml-4.05.0.patch
  [ Gianfranco Costamagna ]
  * Drop debian/README.Debian. We don't need to repack anymore the sources,
    because embedded libraries have been removed upstream

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 20 Mar 2020 19:14:20 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

FRAMA_DIR=$(CURDIR)/debian/tmp
FRAMA_PLUGINS_DIR=$(CURDIR)/debian/frama-c-base/usr/lib/frama-c/plugins/

override_dh_auto_configure:
	mkdir -p lib/plugins
	touch .depend .make-clean .make-clean-stamp
	[ ! -f src/kernel/config.ml ] || cp src/kernel/config.ml src/kernel/config.ml.debian
	autoconf
	./configure $(CROSS) --prefix=/usr       \
		--mandir=\$${prefix}/share/man   \
		--infodir=\$${prefix}/share/info \
		--datarootdir=\$${prefix}/share  \
		--enable-verbosemake             \
		CFLAGS="$(CFLAGS)"               \
		LDFLAGS="-Wl,-z,defs"

FRAMA_PLUGINS=$(wildcard lib/plugins/*.cmx lib/plugins/*.cmxa)

override_dh_auto_install:
	$(MAKE) prefix=$(FRAMA_DIR)/usr FRAMAC_DATADIR=$(FRAMA_DIR)/usr/share/frama-c install
	# Fix permission of .c and .h files (they don't have to be executable)
	find debian/ -name "*.c" -or -name "*.h" -exec chmod a-x '{}' \;
	# Remove useless binaries
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/ptests.byte
	# On Bytecode architectures, bin/frama-c.byte is sam as bin/frama-c
ifeq ($(OCAML_OPT_ARCH),)
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/frama-c.byte
endif

override_dh_auto_clean:
	touch .depend
	[ ! -f src/kernel/config.ml.debian ] || mv src/kernel/config.ml.debian src/kernel/config.ml
	[ ! -f Makefile -o ! -f share/Makefile.config ] || $(MAKE) clean
	$(RM) -rf lib .depend

override_dh_ocaml:
	dh_ocaml --nodefined-map=frama-c-base:Big_int_Z,Z,Q

%:
	dh $@ --with ocaml

=== debian/watch ===
version=3
opts="dversionmangle=s/\+.*$//" \
http://frama-c.com/download.html download/frama-c-.*-([0-9]+)\.tar\.gz

## frama-c 20200625+scandium

=== Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2020                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file is the main makefile of Frama-C.

FRAMAC_SRC=.
MAKECONFIG_DIR=share
PLUGIN_TESTS_LIST:=
include share/Makefile.common
include share/Makefile.dynamic_config.internal

#Check share/Makefile.config available
ifndef FRAMAC_ROOT_SRCDIR
$(error \
  "You should run ./configure first (or autoconf if there is no configure)")
endif

###################
# Frama-C Version #
###################

VERSION:=$(shell $(CAT) VERSION)
VERSION_CODENAME:=$(shell $(CAT) VERSION_CODENAME)

###########################
# Global plugin variables #
###########################

# the directory where compiled plugin non-GUI files are stored
PLUGIN_TOP_LIB_DIR= $(PLUGIN_LIB_DIR)/top

# the directory where compiled plugin GUI files are stored
PLUGIN_GUI_LIB_DIR= $(PLUGIN_LIB_DIR)/gui

# the directory where the other Makefiles are
FRAMAC_SHARE	= share

# Shared lists between Makefile.plugin and Makefile :
# initialized them as "simply extended variables" (with :=)
# for a correct behavior of += (see section 6.6 of GNU Make manual)
PLUGIN_LIST	:=
PLUGIN_GENERATED_LIST:=
PLUGIN_CMO_LIST	:=
PLUGIN_CMX_LIST	:=
PLUGIN_META_LIST :=
PLUGIN_DYN_CMI_LIST :=
PLUGIN_DYN_CMO_LIST :=
PLUGIN_DYN_CMX_LIST :=
PLUGIN_INTERNAL_CMO_LIST:=
PLUGIN_INTERNAL_CMX_LIST:=
PLUGIN_GUI_CMO_LIST:=
PLUGIN_GUI_CMX_LIST:=
PLUGIN_DYN_DEP_GUI_CMO_LIST:=
PLUGIN_DYN_DEP_GUI_CMX_LIST:=
PLUGIN_DYN_GUI_CMO_LIST :=
PLUGIN_DYN_GUI_CMX_LIST :=
PLUGIN_TYPES_CMO_LIST :=
PLUGIN_TYPES_CMX_LIST :=
PLUGIN_DEP_LIST:=
PLUGIN_DOC_LIST :=
PLUGIN_DOC_DIRS :=
PLUGIN_DISTRIBUTED_LIST:=
PLUGIN_DIST_TARGET_LIST:=
PLUGIN_DIST_DOC_LIST:=
PLUGIN_BIN_DOC_LIST:=
PLUGIN_DIST_EXTERNAL_LIST:=
PLUGIN_DIST_TESTS_LIST:=
PLUGIN_DISTRIBUTED_NAME_LIST:=
MERLIN_PACKAGES:=

PLUGIN_HEADER_SPEC_LIST :=
PLUGIN_HEADER_DIRS_LIST :=
PLUGIN_HEADER_EXCEPTIONS_LIST :=
PLUGIN_CEA_PROPRIETARY_HEADERS_LIST :=
PLUGIN_CEA_PROPRIETARY_FILES_LIST :=

# default value used for HEADER_SPEC and PLUGIN_HEADER_SPEC
DEFAULT_HEADER_SPEC := headers/header_spec.txt
# default value used for HEADER_DIRS and PLUGIN_HEADER_DIRS
DEFAULT_HEADER_DIRS := headers
# default value used for HEADER_EXCEPTIONS and PLUGIN_HEADER_EXCEPTIONS
DEFAULT_HEADER_EXCEPTIONS := configure
# default value used for CEA_PROPRIETARY_FILES and PLUGIN_CEA_PROPRIETARY_FILES
DEFAULT_CEA_PROPRIETARY_FILES := tests/non-free/%
# default value used for CEA_PROPRIETARY_HEADERS
# and PLUGIN_CEA_PROPRIETARY_HEADERS
DEFAULT_CEA_PROPRIETARY_HEADERS := CEA_PROPRIETARY

MERLIN_PACKAGES:=

###############################
# Additional global variables #
###############################

# Directories containing some source code
SRC_DIRS= ptests $(PLUGIN_LIB_DIR) $(FRAMAC_SRC_DIRS)

# Directory containing source code documentation
DOC_DIR	= doc/code

# Source files to document
MODULES_TODOC=

# Directories to include when compiling
INCLUDES=$(addprefix -I ,$(FRAMAC_SRC_DIRS)) -I $(PLUGIN_LIB_DIR)
ifneq ($(ENABLE_GUI),no)
GUI_INCLUDES = $(addprefix -package ,$(LIBRARY_NAMES_GUI))
else
GUI_INCLUDES =
endif

# Files for which dependencies must be computed.
# Other files are added later in this Makefile.
FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli

BFLAGS	= $(PACKAGES) $(FLAGS) $(DEBUG) $(INCLUDES) \
		$(FRAMAC_USER_BFLAGS)
OFLAGS	= $(PACKAGES) $(FLAGS) $(DEBUG) $(INCLUDES) -compact \
		$(FRAMAC_USER_OFLAGS)

BLINKFLAGS += -linkpkg $(BFLAGS) -linkall -custom
OLINKFLAGS += -linkpkg $(OFLAGS) -linkall

DOC_FLAGS= -charset utf8 -colorize-code -stars -m A $(PACKAGES) $(INCLUDES) $(GUI_INCLUDES)

ifneq ($(VERBOSEMAKE),yes)
DOC_FLAGS+= -hide-warnings
endif

# Files that depend on external libraries -namely Zarith- whose interface
# has not been explicitely declared -opaque, hence would trigger warning 58.
# This can't be solved by Frama-C itself, we can only wait for an update of
# said library.

NON_OPAQUE_DEPS:=

# Libraries generated by Frama-C
GEN_BYTE_LIBS=
GEN_OPT_LIBS=

# Libraries used in Frama-C
EXTRA_OPT_LIBS:=
PACKAGES = $(addprefix -package ,$(LIBRARY_NAMES))
BYTE_LIBS = $(GEN_BYTE_LIBS)
OPT_LIBS = $(EXTRA_OPT_LIBS)

OPT_LIBS+= $(GEN_OPT_LIBS)

ICONS:= $(addprefix share/,\
		frama-c.ico frama-c.png unmark.png \
		switch-on.png switch-off.png)

THEME_ICON_NAMES:= \
		never_tried.png \
		unknown.png \
		surely_valid.png \
		surely_invalid.png \
		considered_valid.png \
		valid_under_hyp.png \
		invalid_under_hyp.png \
		invalid_but_dead.png \
		unknown_but_dead.png \
		valid_but_dead.png \
		inconsistent.png \
		fold.png unfold.png

THEME_ICONS_DEFAULT:= \
  $(addprefix share/theme/default/,$(THEME_ICON_NAMES))
THEME_ICONS_COLORBLIND:= \
  $(addprefix share/theme/colorblind/,$(THEME_ICON_NAMES))
THEME_ICONS_FLAT:= \
  $(addprefix share/theme/flat/,$(THEME_ICON_NAMES))

ROOT_LIBC_DIR:= share/libc
LIBC_SUBDIRS:= sys netinet net arpa
LIBC_DIR:= $(ROOT_LIBC_DIR) $(addprefix $(ROOT_LIBC_DIR)/,$(LIBC_SUBDIRS))
LIBC_FILES:= \
	$(wildcard share/*.h share/*.c) \
	$(wildcard $(addsuffix /*.h,$(LIBC_DIR))) \
	$(wildcard $(addsuffix /*.c,$(LIBC_DIR)))

# Checks that all .h can be included multiple times.
ALL_LIBC_HEADERS:=$(wildcard share/*.h $(addsuffix /*.h,$(LIBC_DIR)))

check-libc: bin/toplevel.$(OCAMLBEST)$(EXE)
	@echo "checking libc..."; \
	 EXIT_VALUE=0; \
	 for file in $(filter-out share/builtin.h,$(ALL_LIBC_HEADERS)); do \
	   echo "#include \"$$file\"" > check-libc.c; \
	   echo "#include \"$$file\"" >> check-libc.c; \
	   FRAMAC_SHARE=share bin/toplevel.$(OCAMLBEST)$(EXE) \
	   -cpp-extra-args="-Ishare/libc -nostdinc" check-libc.c \
	       > $$(basename $$file .h).log 2>&1; \
	   if test $$? -ne 0; then \
	     if grep -q -e '#error "Frama-C:' $$file; then : ; \
	     else \
	       echo "$$file cannot be included twice. \
Output is in $$(basename $$file .h).log"; \
	       EXIT_VALUE=1; \
	     fi; \
	   else \
	     rm $$(basename $$file .h).log; \
	   fi; \
	 done; \
	 rm check-libc.c; \
	 exit $$EXIT_VALUE

clean-check-libc:
	$(RM) *.log

# Kernel files to be included in the distribution.
# Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
# than *.ml* files in their directory.
# NB: configure for the distribution is generated in the distrib directory
# itself, rather than copied: otherwise, it could include references to
# non-distributed plug-ins.
DISTRIB_FILES:=\
      $(wildcard bin/migration_scripts/*2*.sh) bin/local_export.sh      \
      bin/frama-c bin/frama-c.byte bin/frama-c-gui bin/frama-c-gui.byte \
      bin/frama-c-config bin/frama-c-script                             \
      share/frama-c.WIN32.rc share/frama-c.Unix.rc                      \
      $(ICONS) $(THEME_ICONS_DEFAULT) $(THEME_ICONS_COLORBLIND)         \
      $(THEME_ICONS_FLAT)                                               \
      man/frama-c.1 doc/README						\
      doc/code/docgen.ml                                                \
      doc/code/*.css doc/code/intro_plugin.txt				\
      doc/code/intro_plugin_D_and_S.txt                                 \
      doc/code/intro_plugin_default.txt                                 \
      doc/code/intro_kernel_plugin.txt					\
      doc/code/toc_head.htm                                             \
      doc/code/toc_tail.htm                                             \
      doc/Makefile                                                      \
      $(filter-out ptests/ptests_config.ml,$(wildcard ptests/*.ml*))   \
      configure.in Makefile Makefile.generating				\
      Changelog config.h.in						\
      VERSION VERSION_CODENAME $(wildcard licenses/*)                   \
      $(LIBC_FILES)							\
      share/analysis-scripts/benchmark_database.py                      \
      share/analysis-scripts/cmd-dep.sh                                 \
      share/analysis-scripts/concat-csv.sh                              \
      share/analysis-scripts/clone.sh                                   \
      share/analysis-scripts/creduce.sh                                 \
      $(wildcard share/analysis-scripts/examples/*)                     \
      share/analysis-scripts/fc_stubs.c                                 \
      share/analysis-scripts/find_fun.py                                \
      share/analysis-scripts/flamegraph.pl                              \
      share/analysis-scripts/frama-c.mk                                 \
      share/analysis-scripts/frama_c_results.py                         \
      share/analysis-scripts/git_utils.py                               \
      share/analysis-scripts/list_files.py                              \
      share/analysis-scripts/make_template.py                           \
      share/analysis-scripts/make_wrapper.py                            \
      share/analysis-scripts/parse-coverage.sh                          \
      share/analysis-scripts/README.md                                  \
      share/analysis-scripts/results_display.py                         \
      share/analysis-scripts/summary.py                                 \
      share/analysis-scripts/template.mk                                \
      $(wildcard share/emacs/*.el) share/autocomplete_frama-c           \
      share/_frama-c                                                    \
      share/compliance/c11_functions.json                               \
      share/compliance/glibc_functions.json                             \
      share/compliance/nonstandard_identifiers.json                     \
      share/compliance/posix_identifiers.json                           \
      share/configure.ac                                                \
      share/Makefile.config.in share/Makefile.common                    \
      share/Makefile.generic						\
      share/Makefile.plugin.template share/Makefile.dynamic		\
      share/Makefile.dynamic_config.external				\
      share/Makefile.dynamic_config.internal				\
      share/META.frama-c                                                \
      $(filter-out src/kernel_internals/runtime/fc_config.ml,              \
	  $(wildcard src/kernel_internals/runtime/*.ml*))               \
      $(wildcard src/kernel_services/abstract_interp/*.ml*)             \
      $(wildcard src/plugins/gui/*.ml*)                                 \
      $(wildcard src/libraries/stdlib/*.ml*)                            \
      $(wildcard src/libraries/utils/*.ml*)                             \
      $(wildcard src/libraries/utils/*.c)                               \

=== debian/changelog ===
frama-c (20200625+scandium-2build1) groovy; urgency=medium

  * No-change rebuild against latest lablgtk3

 -- Jeremy Bicha <jbicha@debian.org>  Sat, 03 Oct 2020 20:38:06 -0400

frama-c (20200625+scandium-2) unstable; urgency=medium

  * Drop removal of ptests.byte from debian/rules as it is not installed
    anyway, and mark it as not installed.
  * Fix pathname in removing redundant frama-c.byte

 -- Ralf Treinen <treinen@debian.org>  Wed, 26 Aug 2020 08:39:38 +0200

frama-c (20200625+scandium-1) unstable; urgency=medium

  * New upstream release.
    This version works with why3 1.3.1 (closes: #963705)
    This version solves FTBFS (closes: #959599)
  * Add myself as uploader
  * Add dependency on ${perl:Depends} and dependency on python3
  * Build-dependencies:
    - use debhelper-compat, remove file debian/compat
    - bump versions according to upstream's opam file
    - drop ocaml-best-compilers which is now a virtual package
    - add liblablgtk{sourceview}3-ocaml-dev
  * Debhelper-compatibility level 13
    - invoke dh --without autoreconf
  * Installation:
    - install the complete directory /usr/lib/frama-c/plugins
    - install usr/lib/libeacsl-dlmalloc.a
    - install frama-c-script and frama-c-gui binaries
    - register ptests and e-acsl-gcc as not installed
  * Add symbolic link for the manpage of frama-c-gui.byte
  * d/copyright:
    - remove entries concerning files that are no longer in the source tree.
    - add text of the BSD-3 license, rename to BSD-3-clause
    - migrate to machine-readable format 1.0
    - remove copy of LGPL 2.1
  * Fix format of long description
  * Standards-Version 4.5.0
  * Update Homepage

 -- Ralf Treinen <treinen@debian.org>  Tue, 25 Aug 2020 20:37:33 +0200

=== debian/control ===
Source: frama-c
Section: devel
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Mehdi Dogguy <mehdi@debian.org>,
 Ralf Treinen <treinen@debian.org>
Build-Depends:
 debhelper-compat (=13),
 ocaml-nox (>= 4.08.1),
 dh-ocaml (>= 0.9~),
 graphviz,
 autoconf,
 libzarith-ocaml-dev,
 ocaml-findlib,
 libfindlib-ocaml-dev,
 libyojson-ocaml-dev,
 libwhy3-ocaml-dev (>= 1.3.1),
 libocamlgraph-ocaml-dev (>= 1.8.8),
 liblablgtk3-ocaml-dev (>= 3.0~beta4),
 liblablgtksourceview3-ocaml-dev
Standards-Version: 4.5.0
Homepage: https://frama-c.com
Vcs-Browser: https://salsa.debian.org/ocaml-team/frama-c
Vcs-Git: https://salsa.debian.org/ocaml-team/frama-c.git

Package: frama-c-base
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 ${perl:Depends},
 libocamlgraph-ocaml-dev,
 gcc,
 python3
Recommends:
 alt-ergo
Description: Platform dedicated to the analysis of source code written in C (without gui)
 Frama-C gathers several analysis techniques in a single collaborative
 framework, based on analyzers (called "plug-ins") that can build upon the
 results computed by other analyzers in the framework.
 .
 Thanks to this approach, Frama-C provides sophisticated tools, including:
   * an analyzer based on abstract interpretation (Value plug-in);
   * a program proof framework based on weakest precondition calculus
     (WP plug-in);
   * a program slicer (Slicing plug-in);
   * a tool for verification of temporal (LTL) properties (Aoraï plug-in);
   * several tools for code base exploration and dependency analysis
     (plug-ins From, Impact, Metrics, Occurrence, Scope, etc.).
 .
 These plug-ins communicate between each other via the Frama-C API
 and via ACSL (ANSI/ISO C Specification Language) properties.
 .
 This package provides the library of Frama-c which is useful to build
 plugins for Frama-c and the command-line tools.

## frama-c 20201209+titanium

=== Makefile ===
--- 
+++ 
@@ -254,22 +254,25 @@
       Changelog config.h.in						\
       VERSION VERSION_CODENAME $(wildcard licenses/*)                   \
       $(LIBC_FILES)							\
+      share/analysis-scripts/analysis.mk                                \
       share/analysis-scripts/benchmark_database.py                      \
       share/analysis-scripts/cmd-dep.sh                                 \
       share/analysis-scripts/concat-csv.sh                              \
       share/analysis-scripts/clone.sh                                   \
       share/analysis-scripts/creduce.sh                                 \
-      $(wildcard share/analysis-scripts/examples/*)                     \
+      share/analysis-scripts/epilogue.mk                                \
       share/analysis-scripts/fc_stubs.c                                 \
       share/analysis-scripts/find_fun.py                                \
       share/analysis-scripts/flamegraph.pl                              \
-      share/analysis-scripts/frama-c.mk                                 \
       share/analysis-scripts/frama_c_results.py                         \
+      share/analysis-scripts/function_finder.py                         \
       share/analysis-scripts/git_utils.py                               \
       share/analysis-scripts/list_files.py                              \
       share/analysis-scripts/make_template.py                           \
       share/analysis-scripts/make_wrapper.py                            \
+      share/analysis-scripts/normalize_jcdb.py                          \
       share/analysis-scripts/parse-coverage.sh                          \
+      share/analysis-scripts/prologue.mk                                \
       share/analysis-scripts/README.md                                  \
       share/analysis-scripts/results_display.py                         \
       share/analysis-scripts/summary.py                                 \
@@ -291,6 +294,3 @@
 	  $(wildcard src/kernel_internals/runtime/*.ml*))               \
       $(wildcard src/kernel_services/abstract_interp/*.ml*)             \
       $(wildcard src/plugins/gui/*.ml*)                                 \
-      $(wildcard src/libraries/stdlib/*.ml*)                            \
-      $(wildcard src/libraries/utils/*.ml*)                             \
-      $(wildcard src/libraries/utils/*.c)                               \

=== doc/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2019                                               #
+#  Copyright (C) 2007-2020                                               #
 #    CEA (Commissariat à l'énergie atomique et aux énergies              #
 #         alternatives)                                                  #
 #                                                                        #

=== src/plugins/print_api/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2020                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Print_api plugin
##################

# Frama-C should be properly installed with "make install"
# befor any use of this makefile

ifndef FRAMAC_SHARE
FRAMAC_SHARE	:=$(shell frama-c.byte -print-path)
endif
ifndef FRAMAC_LIBDIR
FRAMAC_LIBDIR	:=$(shell frama-c.byte -print-libpath)
endif

PLUGIN_DIR	?= .
PLUGIN_NAME	:= Print_api
PLUGIN_CMO	:= grammar lexer print_interface
PLUGIN_GENERATED:= $(PLUGIN_DIR)/grammar.ml $(PLUGIN_DIR)/grammar.mli \
		$(PLUGIN_DIR)/lexer.ml
PLUGIN_DISTRIB_EXTERNAL:=Makefile

include $(FRAMAC_SHARE)/Makefile.dynamic

clean:: 
	$(RM) $(Print_api_DIR)/dynamic_plugins.mli
	$(RM) $(Print_api_DIR)/grammar.output
	$(RM) $(Print_api_DIR)/grammar.ml
	$(RM) $(Print_api_DIR)/grammar.mli
	$(RM) $(Print_api_DIR)/lexer.ml
	$(RM) -r _build

=== src/plugins/qed/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #                                                                        #
 #  This file is part of WP plug-in of Frama-C.                           #
 #                                                                        #
-#  Copyright (C) 2007-2019                                               #
+#  Copyright (C) 2007-2020                                               #
 #    CEA (Commissariat a l'energie atomique et aux energies              #
 #         alternatives)                                                  #
 #                                                                        #

=== debian/changelog ===
frama-c (20201209+titanium-4.1) unstable; urgency=medium

  * Non-maintainer upload
  * Fix new eva test dependencies and return in case of error (Closes:
    #982148)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Feb 2021 23:09:31 +0100

frama-c (20201209+titanium-4) unstable; urgency=medium

  * Add a test for the eva plugin
  * Test of the wp plugin: set skip-not-installable, since alt-ergo
    and why3 might be not installable.

 -- Ralf Treinen <treinen@debian.org>  Mon, 11 Jan 2021 20:17:46 +0100

frama-c (20201209+titanium-3) unstable; urgency=medium

  * Patch 0001-E-ACSL-avoid-cmx-dependencies-when-in-a-byte-only-ar.patch:
    fix FTBFS on bytecode architectures (closes: #979569).
    Thanks to André Maroneze for the patch
  * Add Recommends libwhy3-ocaml-dev, as it is needed by frama-c to run why3.
  * Test wp:
    - add test-dependency libwhy3-ocaml-dev
    - run why3 config

 -- Ralf Treinen <treinen@debian.org>  Fri, 08 Jan 2021 21:32:55 +0100

frama-c (20201209+titanium-2) unstable; urgency=medium

  * Add recommends why3 (for the wp plugin)
  * Test wp: add depends on why3

 -- Ralf Treinen <treinen@debian.org>  Sun, 03 Jan 2021 10:35:26 +0100

frama-c (20201209+titanium-1) unstable; urgency=medium

  * New upstream release.
  * Drop patch 0004-Use-ocamlfind-package-lablgtk2-gnome.gnomecanvas as
    we are building against lablgtk3; refresh the other patches.
  * Standards-Version 4.5.1 (no change)
  * Rules-Requires-Root=no
  * Update package description (we also ship the gui)
  * Add as-installed package tests:
    - wp (deductive verification with alt-ergo)
  * gbp configuration : add filter for the executable in the spamassassin test

 -- Ralf Treinen <treinen@debian.org>  Sat, 02 Jan 2021 10:59:17 +0100

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,8 @@
  libocamlgraph-ocaml-dev (>= 1.8.8),
  liblablgtk3-ocaml-dev (>= 3.0~beta4),
  liblablgtksourceview3-ocaml-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
+Rules-Requires-Root: no
 Homepage: https://frama-c.com
 Vcs-Browser: https://salsa.debian.org/ocaml-team/frama-c
 Vcs-Git: https://salsa.debian.org/ocaml-team/frama-c.git
@@ -34,8 +35,8 @@
  gcc,
  python3
 Recommends:
- alt-ergo
-Description: Platform dedicated to the analysis of source code written in C (without gui)
+ alt-ergo, why3, libwhy3-ocaml-dev
+Description: Platform dedicated to the analysis of source code written in C
  Frama-C gathers several analysis techniques in a single collaborative
  framework, based on analyzers (called "plug-ins") that can build upon the
  results computed by other analyzers in the framework.
@@ -53,4 +54,4 @@
  and via ACSL (ANSI/ISO C Specification Language) properties.
  .
  This package provides the library of Frama-c which is useful to build
- plugins for Frama-c and the command-line tools.
+ plugins for Frama-c, the command-line tools, and the graphical interface.

=== debian/rules ===
--- 
+++ 
@@ -27,11 +27,9 @@
 	$(MAKE) prefix=$(FRAMA_DIR)/usr FRAMAC_DATADIR=$(FRAMA_DIR)/usr/share/frama-c install
 	# Fix permission of .c and .h files (they don't have to be executable)
 	find debian/ -name "*.c" -or -name "*.h" -exec chmod a-x '{}' \;
-	# Remove useless binaries
-	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/ptests.byte
-	# On Bytecode architectures, bin/frama-c.byte is sam as bin/frama-c
+	# On bytecode architectures, bin/frama-c.byte is same as bin/frama-c
 ifeq ($(OCAML_OPT_ARCH),)
-	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/frama-c.byte
+	$(RM) -f $(CURDIR)/debian/tmp/usr/bin/frama-c.byte
 endif
 
 override_dh_auto_clean:
@@ -44,4 +42,4 @@
 	dh_ocaml --nodefined-map=frama-c-base:Big_int_Z,Z,Q
 
 %:
-	dh $@ --with ocaml
+	dh $@ --with ocaml --without autoreconf

=== debian/tests/control ===
Tests: eva
Depends: frama-c-base, why3, libwhy3-ocaml-dev

Tests: wp
Depends: frama-c-base, alt-ergo (>= 2.0.0), why3, libwhy3-ocaml-dev
Restrictions: skip-not-installable
